#include "fontgl.h"
#include <GL/glut.h>





/* Gestion des Msg en OpenGL */

MsgGL::MsgGL(int w,int h)
{
  width=w;
  height=h;
  curX=0;
  curY=0;
  size_y=24;
  size_x=20;
  color_r=color_g=color_b=1.0;
}

void MsgGL::TakeC()
{
  glMatrixMode(GL_PROJECTION);
  glPushMatrix();
  glLoadIdentity();
  gluOrtho2D(0, width, 0, height);
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glLoadIdentity();
  glTranslatef(0, height-24, 0);
  glRasterPos2i(0, 0);
}

void MsgGL::RendreC()
{
  glMatrixMode(GL_PROJECTION);
  glPopMatrix();glPopMatrix();
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix();
}


void MsgGL::PutChar(char c)
{
  curX++;
  glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_24,c);
}

void MsgGL::RetourChar()
{
  curY++;
  curX=0;
  glRasterPos2f(0,-(curY)*size_y);
}

void MsgGL::Reset()
{
  curY=curX=0;
  glRasterPos2f(0,0);
}

void MsgGL::Printf(char *str)
{
  if(str==0)
    return;
  while(*str!=0){
    if(*str=='\n'){
      RetourChar();
      str++;
    }
    else {
      PutChar(*str);
      str++;
    }
  }
}

void MsgGL::Printf(char *str,int x, int y)
{
  if(str==0)
    return;
  glRasterPos2f(x,-y);
  while(*str!=0){
    if(*str=='\n'){
      str++;
    }
    else {
      glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_24,*str);
      str++;
    }
  }
}
