#ifndef __LOADGL_H
#define __LOADGL_H

#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <list>
using namespace std;


// include necessary to 3D
#include "cobj.h"
#include "face.h"

// include necessary to physics
#include "sp_circuit.h"


/* Cette classe selectionne les faces dont les indices */
class __indice_list
{
  public:
        // les fonctions membres
    __indice_list(int nb);
        // ajoute et supprime des indices dans la liste
    void Add_Indice(unsigned int ind);
    void Rem_Indice(unsigned int ind);
        // L indice est il dans la liste ?
    int isIndiceInList(unsigned int ind);
        // selectionne dans les triangles
    unsigned int *select_face_in(unsigned int *data,int nb_faces,int *nb_trouve);
    unsigned int *select_face_out(unsigned int *data,int nb_faces,int *nb_trouve);  
        // les indices
    list<unsigned int> liste_indices;
        // le nombre de points de la shape
    int nb_points;
};



class Sp_Obj_gl: public Sp_Obj3d
{
  public:
    Sp_Obj_gl(char *filename,Sp_Adm *gest3d,Sp_Obj *ton_pere,int priority);
    virtual void Draw();
    virtual void Work();
};


class Sp_Load_CircuitC: public Sp_CircuitC
{
  public:
        //the constructors
    Sp_Load_CircuitC(char *filename);
    
};

#endif
