#ifndef __SP_CAR_H
#define __SP_CAR_H

#include "sp_circuit.h"
#include "cobj.h"

/* It is an camera posed on a circuit */



class Sp_Car: public Sp_Camera
{
 public:
        // The members functions
        // constructors
  Sp_Car(char *name,Sp_Adm *gest3d,Sp_Obj *ton_pere);
  
      // Init the Sp_car on the circuit with a point
  void Init(Sp_CircuitC *,Sp_Point &,Sp_Vecteur &direction);

      // Calcule next position
  void Compute_Next_Postion(float speed,float elapsed);

  void Work();
  
  public:
  Sp_Trans *position;
  
  public:
  // the members data
  //    the circuit
  Sp_CircuitC *circuit;
  //    the current face
  Sp_FaceC *face;

  //  a repere
  //    the coordinate
  Sp_Point O;
  //    the vectors;
  Sp_Vecteur i;
  Sp_Vecteur k;
  float vspeed;
  void Accelerate(float val);
  // functions simply used internally
 private:
  //    this functions search the face current
  Sp_FaceC *find_init(Sp_Point &);

};







#endif
