#ifndef SP_CHUNK_H
#define SP_CHUNK_H

#include <list>
using namespace std;



// The class to do load and save file  

class Sp_Chunk
{
  public:
    Sp_Chunk();
        // where to load the chunk (report error)
    virtual int Load(char *);
        // where to save the chunk (report error)
    virtual int Save(char *);

        // give the size of the chunk in octets
    virtual int GetSize();
        // give the type of the chunk
    int GetType();

        // Add and remove a chunk son
    void Add_Chunk(Sp_Chunk *);
    void Rem_Chunk(Sp_Chunk *);
    

    
  protected:
        // set the size
    virtual void SetProperSize(int);
        // set the type of the chunk
    void SetType(int);

  
    
  private:
        // must be 32bits
    int proper_size;
        // the type of chunk
    int type;
        // list of son chunk
    list<Sp_Chunk *> list_sons;
};









#endif
